import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';

var _class, _temp2;

import React from 'react';
import PropTypes from 'prop-types';

//中转作用
var __Locale__ = void 0;
//切换后的语言列表
var changedLanguageList = void 0;
//后面会赋值
var getLanguageSpecificListTemp = void 0;
export function switchLanguage(language) {
  if (!getLanguageSpecificListTemp) {
    console.error('switchLanguage 先执行getLanguageSpecificListTemp为undefined.');
    return;
  }
  var languageListPromise = getLanguageSpecificListTemp && getLanguageSpecificListTemp(language);
  if (!languageListPromise.then && !languageListPromise.catch) {
    console.error('"getLanguageSpecificList" should return promise!');
    return;
  }
  return languageListPromise.then(function (languageList) {
    if (!languageList) {
      return false;
    }
    //兼容es6语法
    languageList = languageList.default || languageList;
    //记录当前的language
    localStorage.currentLanguage = language;
    changedLanguageList = languageList;
    return languageList;
  });
}

export function t(str) {
  if (changedLanguageList) {
    var o = changedLanguageList[__Locale__[str]];
    if (o) {
      return o;
    }
  }
  return str;
}

/**
 * @prop { function } getLanguageSpecificList 获取指定的语言列表，返回promise对象
 * 参数为各种语言的标识字符串，返回指定语言的数组列表（promise对象）
 */
var I18nProvider = (_temp2 = _class = function (_React$Component) {
  _inherits(I18nProvider, _React$Component);

  function I18nProvider() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, I18nProvider);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = I18nProvider.__proto__ || _Object$getPrototypeOf(I18nProvider)).call.apply(_ref, [this].concat(args))), _this), _this.displayName = 'I18nProvider', _this.state = {}, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(I18nProvider, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var _props = this.props,
          getLanguageSpecificList = _props.getLanguageSpecificList,
          _props$defaultLanguag = _props.defaultLanguageList,
          defaultLanguageList = _props$defaultLanguag === undefined ? [] : _props$defaultLanguag;

      getLanguageSpecificListTemp = getLanguageSpecificList;
      if (!__Locale__) {
        __Locale__ = {};
        defaultLanguageList.forEach(function (v, k) {
          __Locale__[v] = k;
        });
      }
      if (localStorage.currentLanguage) {
        var switchLanguagePromise = switchLanguage(localStorage.currentLanguage);
        if (switchLanguagePromise && switchLanguagePromise.then) {
          switchLanguagePromise.then(function (languageList) {
            _this2.setState({
              canRender: true
            });
          });
        }
      } else {
        this.setState({
          canRender: true
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          children = _props2.children,
          I18nLoading = _props2.I18nLoading;
      var canRender = this.state.canRender;

      if (!canRender && localStorage.currentLanguage) {
        if (I18nLoading) {
          return React.createElement(I18nLoading, null);
        }
        return false;
      } else {
        return React.createElement(
          'span',
          null,
          children
        );
      }
    }
  }]);

  return I18nProvider;
}(React.Component), _class.propTypes = {
  getLanguageSpecificList: PropTypes.func.isRequired,
  defaultLanguageList: PropTypes.array.isRequired,
  I18nLoading: PropTypes.element
}, _temp2);
export { I18nProvider as default };